<?php

// register and enqueue CSS styles
function theme_styles_scripts () {
	
	wp_register_style('theme',get_stylesheet_directory_uri().'/style.css', array(), false, 'all');
	wp_register_style('responsive',get_template_directory_uri().'/responsive.css', array(), false, 'all');
	wp_register_style('orbit',get_template_directory_uri().'/scripts/orbit/orbit-1.2.3.css', array(), false, 'all');
	wp_register_style('fontawesome',get_template_directory_uri().'/includes/font-awesome/css/font-awesome.min.css', array(), false, 'all');
	
	wp_enqueue_style('responsive');
	wp_enqueue_style('theme');
	wp_enqueue_style('orbit');
	wp_enqueue_style('fontawesome');
	
	wp_register_script('fitvids', get_template_directory_uri() . '/scripts/fitvids/jquery.fitvids.js', array('jquery'), false, true);
	wp_register_script('orbitslider', get_template_directory_uri() . '/scripts/orbit/jquery.orbit-1.2.3.js', array('jquery'), '1.2.3', false);
	wp_register_script('isotope', get_template_directory_uri() . '/scripts/isotope/jquery.isotope.min.js', array('jquery'), false, true);
	wp_register_script('retina', get_template_directory_uri() . '/scripts/retina/retina.js', array('jquery'), false, true);
	wp_register_script('infinitescroll', get_template_directory_uri() . '/scripts/infinitescroll/jquery.infinitescroll.js', array('jquery'), false, true);

	wp_enqueue_script('isotope');
	wp_enqueue_script('orbitslider');
	wp_enqueue_script('fitvids');
	wp_enqueue_script('retina');
	wp_enqueue_script('infinitescroll');

}
add_action('wp_enqueue_scripts', 'theme_styles_scripts');

function load_admin_style() {
        wp_register_style( 'admin_css', get_template_directory_uri() . '/admin-style.css', array(), null, 'all' );
        wp_enqueue_style( 'admin_css' );
}
add_action( 'admin_enqueue_scripts', 'load_admin_style' );

function colorpicker_init () {
	
	wp_register_style('colorpicker',get_template_directory_uri().'/scripts/colorpicker/css/colorpicker.css', array(), false, 'all');
	wp_enqueue_style('colorpicker');

	wp_register_script('colorpickerjs', get_template_directory_uri() . '/scripts/colorpicker/js/colorpicker.js', array('jquery'), false, true);
	wp_enqueue_script('colorpickerjs');

}
add_action( 'admin_enqueue_scripts', 'colorpicker_init' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Set the content width
if ( ! isset( $content_width ) )
    $content_width = 1001;
 
function theme_adjust_content_width() {
    global $content_width;
 
    if ( is_page_template( 'page_full-width.php' ) || is_page_template('page_portfolio-one-column.php') || is_page_template('single-project.php') )
    	$content_width = 1920;
}
add_action( 'template_redirect', 'theme_adjust_content_width' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// enables widgetized sidebars
if ( function_exists('register_sidebar') )
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Sidebar Widgets
// Location: the sidebar
register_sidebar(array('name'=>'Sidebar',
	'id' => 'sidebar-1',
	'before_widget' => '<div class="widget-area widget-sidebar %2$s">',
	'after_widget' => '<div class="clearleft"></div></div>',
	'before_title' => '<h3>',
	'after_title' => '</h3><div class="clearleft"></div>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Footer Widgets
// Location: at the top of the footer, above the copyright
register_sidebar(array('name'=>'Footer',
	'id' => 'sidebar-2',
	'before_widget' => '<div class="widget-area widget-footer %2$s">',
	'after_widget' => '</div>',
	'before_title' => '<h4>',
	'after_title' => '</h4>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Activate included plugins on theme activation
require_once dirname( __FILE__ ) . '/includes/class-tgm-plugin-activation.php';
add_action( 'tgmpa_register', 'my_theme_register_required_plugins' );
function my_theme_register_required_plugins() {
    $plugins = array( 
        array(
            'name'                  => 'Advanced Recent Posts', 
            'slug'                  => 'advanced-recent-posts', 
            'source'                => get_template_directory() . '/includes/plugins/advanced-recent-posts.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => false, 
        ),
		array(
            'name'                  => 'Contact Form', 
            'slug'                  => 'contact-form', 
            'source'                => get_template_directory() . '/includes/plugins/contact-form.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => false, 
        ),
		array(
            'name'                  => 'Quick Localization', 
            'slug'                  => 'quick-localization', 
            'source'                => get_template_directory() . '/includes/plugins/quick-localization.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => false, 
        ),
		array(
            'name'                  => 'Advanced SEO', 
            'slug'                  => 'advanced-seo', 
            'source'                => get_template_directory() . '/includes/plugins/advanced-seo.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => false, 
        ),
		array(
            'name'                  => 'Shortcodes', 
            'slug'                  => 'shortcodes', 
            'source'                => get_template_directory() . '/includes/plugins/shortcodes.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => false, 
        ),array(
            'name'                  => 'Social media Widget', 
            'slug'                  => 'social-media-widget', 
            'source'                => get_template_directory() . '/includes/plugins/social-media-widget.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => false, 
        ),array(
            'name'                  => 'Twitter Widget', 
            'slug'                  => 'twitter-widget', 
            'source'                => get_template_directory() . '/includes/plugins/twitter-widget.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => false, 
		)
    );
  
    $config = array(
        'domain'            => 'satori',           
        'default_path'      => '',                          
        'parent_menu_slug'  => 'themes.php',         
        'parent_url_slug'   => 'themes.php',        
        'menu'              => 'install-required-plugins',   
        'has_notices'       => true,                        
        'is_automatic'      => true,            
        'message'           => '',               
        'strings'           => array(
            'page_title'                                => __( 'Install Required Plugins', 'satori' ),
            'menu_title'                                => __( 'Install Required Plugins', 'satori' ),
            'installing'                                => __( 'Installing Plugin: %s', 'satori' ), // %1$s = plugin name
            'oops'                                      => __( 'Something went wrong with the plugin API.', 'satori' ),
            'notice_can_install_required'               => _n_noop( 'This theme requires the following plugin: %1$s.', 'This theme requires the following plugins: %1$s.' ), // %1$s = plugin name(s)
            'notice_can_install_recommended'            => _n_noop( 'This theme recommends the following plugin: %1$s.', 'This theme recommends installing the following pre-packaged plugins: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_install'                     => _n_noop( 'Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.' ), // %1$s = plugin name(s)
            'notice_can_activate_required'              => _n_noop( 'The following required plugin is currently inactive: %1$s.', 'The following required plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
            'notice_can_activate_recommended'           => _n_noop( 'The following recommended plugin is currently inactive: %1$s.', 'The following recommended plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_activate'                    => _n_noop( 'Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.' ), // %1$s = plugin name(s)
            'notice_ask_to_update'                      => _n_noop( 'The following plugin needs to be updated to its latest version to ensure maximum compatibility with this theme: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this theme: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_update'                      => _n_noop( 'Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.' ), // %1$s = plugin name(s)
            'install_link'                              => _n_noop( 'Begin installing plugin', 'Begin installing plugins' ),
            'activate_link'                             => _n_noop( 'Activate installed plugin', 'Activate installed plugins' ),
            'return'                                    => __( 'Return to Required Plugins Installer', 'satori' ),
            'plugin_activated'                          => __( 'Plugin activated successfully.', 'satori' ),
            'complete'                                  => __( 'All plugins installed and activated successfully. %s', 'satori' ) // %1$s = dashboard link
        )
    );
 
    tgmpa( $plugins, $config );
 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add RSS links
add_theme_support( 'automatic-feed-links' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Adds the post thumbnail to the RSS feed
function get_the_content_with_formatting ($more_link_text = '(more...)', $stripteaser = 0, $more_file = '') {
	$content = get_the_content($more_link_text, $stripteaser, $more_file);
	$content = apply_filters('the_content', $content);
	$content = str_replace(']]>', ']]&gt;', $content);
	return $content;
}

function cwc_rss_post_thumbnail($content) {
	global $post;
	if(has_post_thumbnail($post->ID)) {
		$content = '<p>' . get_the_post_thumbnail($post->ID) .
		'</p>' . get_the_content_with_formatting();
	}
	return $content;
}
add_filter('the_excerpt_rss', 'cwc_rss_post_thumbnail');
add_filter('the_content_feed', 'cwc_rss_post_thumbnail');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom menu support
add_theme_support( 'menus' );
if ( function_exists( 'register_nav_menus' ) ) {
	register_nav_menus(
		array(
		  'header-menu' => 'Main Menu'
		)
	);
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Removes Trackbacks from the comment count
add_filter('get_comments_number', 'comment_count', 0);
function comment_count( $count ) {
	if ( ! is_admin() ) {
		global $id;
		$comments_by_type = &separate_comments(get_comments('status=approve&post_id=' . $id));
		return count($comments_by_type['comment']);
	} else {
		return $count;
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// This is needed for the system to create proper versions of uploaded photos and embedded videos
if ( ! isset( $content_width ) ) $content_width = 950;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Invite rss subscribers to comment
function rss_comment_footer($content) {
	if (is_feed()) {
		if (comments_open()) {
			$content .= 'Comments are open! <a href="'.get_permalink().'">Add yours!</a>';
		}
	}
	return $content;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom excerpt ellipses for 2.9+
function custom_excerpt_more($more) {
	return __('Read More', 'satori').'&raquo;';
}
add_filter('excerpt_more', 'custom_excerpt_more');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// No more jumping for read more link
function no_more_jumping($post) {
	if(isset($post->ID)) { return '<a href="'.get_permalink($post->ID).'" class="read-more">'.'&nbsp; Continue Reading &raquo;'.'</a>'; }
}
add_filter('excerpt_more', 'no_more_jumping');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Adds a class to the post if there is a thumbnail
function has_thumb_class($classes) {
	global $post;
	if( has_post_thumbnail($post->ID) ) { 
		$classes[] = 'has_thumb'; 
	}
	return $classes;
}
add_filter('post_class', 'has_thumb_class');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add taxonomies to post class
function tax_class($taxclass) {
	global $post;
	$cats = get_the_terms($post->ID, 'category');
	if ( $cats && ! is_wp_error( $cats ) ) {
		foreach ($cats as $cat) {
			$taxclass[] = strtolower($cat->name);	
		}
	}
	$tags = get_the_terms($post->ID, 'post_tag');
	if ( $tags && ! is_wp_error( $tags ) ) {
		foreach ($tags as $tag) {
			$taxclass[] = strtolower($tag->name);	
		}
	}
	$tagports = get_the_terms($post->ID, 'tagportfolio');
	if ( $tagports && ! is_wp_error( $tagports ) ) {
		foreach ($tagports as $tagport) {
			$taxclass[] = strtolower($tagport->name);
			$taxclass[] = strtolower($tagport->slug);	
		}
	}
	return $taxclass;
}
add_filter('post_class', 'tax_class');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add the .post class to portfolio items
function overall_post_class($classes) {
	global $post;
	if( get_post_type($post->ID) == 'project' ) { $classes[] = 'post'; }
		return $classes;
}
add_filter('post_class', 'overall_post_class');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Make theme available for translation
// Translations can be filed in the /languages/ directory
load_theme_textdomain('satori', get_template_directory() . '/languages');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Enable threaded comments
function enable_threaded_comments(){
if (!is_admin()) {
	if (is_singular() AND comments_open() AND (get_option('thread_comments') == 1))
		wp_enqueue_script('comment-reply');
	}
}
add_action('get_header', 'enable_threaded_comments');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add fancybox support
include_once( get_template_directory(). '/includes/easy-fancybox/easy-fancybox.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add a pager
require_once( get_template_directory(). '/includes/pager/pager.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add dropdown menus for mobile screens
include_once( get_template_directory(). '/includes/dropdown-menus/dropdown-menus.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Option Tree integration
include_once( get_template_directory(). '/includes/option-tree/index.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom sidebars
include_once( get_template_directory(). '/includes/custom-sidebars/customsidebars.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Create portfolio 
add_action('init', 'project_custom_init');      

function project_custom_init()  
{  
// The following is all the names, in our tutorial, we use "Project"
$labels = array(
	'name' => _x('Projects', 'post type general name', 'satori'),
	'singular_name' => _x('Project', 'post type singular name', 'satori'),
	'add_new' => _x('Add New', 'project', 'satori'),
	'add_new_item' => __('Add New Project', 'satori'),
	'edit_item' => __('Edit Project', 'satori'),
	'new_item' => __('New Project', 'satori'),
	'view_item' => __('View Project', 'satori'),
	'search_items' => __('Search Projects', 'satori'),
	'not_found' =>  __('No projects found', 'satori'),
	'not_found_in_trash' => __('No projects found in Trash', 'satori'),
	'parent_item_colon' => '',
	'menu_name' => __('Portfolio', 'satori')
);

// Some arguments and in the last line 'supports', we say to WordPress what features are supported on the Project post type
$args = array(
	'labels' => $labels,
	'public' => true,
	'publicly_queryable' => true,
	'show_ui' => true,
	'show_in_menu' => true,
	'query_var' => true,
	'rewrite' => true,
	'capability_type' => 'post',
	'has_archive' => true,
	'hierarchical' => false,
	'menu_position' => null,
	'supports' => array('title','editor','author','thumbnail','excerpt','comments','post-formats','page-attributes')
);

// We call this function to register the custom post type
register_post_type('project',$args);

// Initialize Taxonomy Labels
$labels = array(
	'name' => _x( 'Tags', 'taxonomy general name' , 'satori'),
	'singular_name' => _x( 'Tag', 'taxonomy singular name', 'satori' ),
	'search_items' =>  __( 'Search Types' , 'satori'),
	'all_items' => __( 'All Tags', 'satori' ),
	'parent_item' => __( 'Parent Tag', 'satori' ),
	'parent_item_colon' => __( 'Parent Tag:', 'satori' ),
	'edit_item' => __( 'Edit Tags', 'satori' ),
	'update_item' => __( 'Update Tag', 'satori' ),
	'add_new_item' => __( 'Add New Tag', 'satori' ),
	'new_item_name' => __( 'New Tag Name', 'satori' ),
);

// Register Custom Taxonomy
register_taxonomy('tagportfolio',array('project'), array(
	'hierarchical' => true, // define whether to use a system like tags or categories
	'labels' => $labels,
	'show_ui' => true,
	'query_var' => true,
	'rewrite' => array( 'slug' => 'tag-portfolio' ),
));
}  

add_filter('post_updated_messages', 'project_updated_messages');

function project_updated_messages( $messages ) {
  global $post, $post_ID;

  $messages['project'] = array(
	0 => '', // Unused. Messages start at index 1.
	1 => sprintf( __('Project updated. <a href="%s">View project</a>', 'satori'), esc_url( get_permalink($post_ID) ) ),
	2 => __('Custom field updated.', 'satori'),
	3 => __('Custom field deleted.', 'satori'),
	4 => __('Project updated.', 'satori'),
	/* translators: %s: date and time of the revision */
	5 => isset($_GET['revision']) ? sprintf( __('Project restored to revision from %s', 'satori'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
	6 => sprintf( __('Project published. <a href="%s">View project</a>', 'satori'), esc_url( get_permalink($post_ID) ) ),
	7 => __('Project saved.', 'satori'),
	8 => sprintf( __('Project submitted. <a target="_blank" href="%s">Preview project</a>', 'satori'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
	9 => sprintf( __('Project scheduled for: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview project</a>', 'satori'),
	  // translators: Publish box date format, see http://php.net/date
	  date_i18n( __( 'M j, Y @ G:i' , 'satori'), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),
	10 => sprintf( __('Project draft updated. <a target="_blank" href="%s">Preview project</a>', 'satori'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
  );

  return $messages;
}

if ( function_exists( 'add_theme_support' ) ) {  
add_theme_support(  'post-thumbnails' );
} 

if ( function_exists( 'get_option_tree' ) && is_string ( get_option_tree( 'boxdim' ) ) )  { 
	$boxdim = get_option_tree( 'boxdim' );
	if ( is_string(get_option_tree( 'boxmar' )) ) { 
		$largeboxdim = $boxdim*2 + get_option_tree( 'boxmar' )*2;
	} else {
		$largeboxdim = $boxdim*2 + 32;
	}
} else {
	$largeboxdim = 552;
}
$largeboxretina = $largeboxdim * 2;
if ( function_exists( 'add_image_size' ) ) {
add_image_size( 'square', $largeboxretina, $largeboxretina, true ); 
}

// Custom post type date archives

function cpt_rewrite_rules($wp_rewrite) {
    $rules = cpt_generate_date_archives('project', $wp_rewrite);
    $wp_rewrite->rules = $rules + $wp_rewrite->rules;
    return $wp_rewrite;
}
add_action('generate_rewrite_rules', 'cpt_rewrite_rules');

function cpt_generate_date_archives($cpt, $wp_rewrite) {
    $rules = array();

    $post_type = get_post_type_object($cpt);
    $slug_archive = $post_type->has_archive;
    if ($slug_archive === false) return $rules;
    if ($slug_archive === true) {
        $slug_archive = $post_type->name;
    }

    $dates = array(
        array(
            'rule' => "([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})",
            'vars' => array('year', 'monthnum', 'day')),
        array(
            'rule' => "([0-9]{4})/([0-9]{1,2})",
            'vars' => array('year', 'monthnum')),
        array(
            'rule' => "([0-9]{4})",
            'vars' => array('year'))
        );

    foreach ($dates as $data) {
        $query = 'index.php?post_type='.$cpt;
        $rule = $slug_archive.'/'.$data['rule'];

        $i = 1;
        foreach ($data['vars'] as $var) {
            $query.= '&'.$var.'='.$wp_rewrite->preg_index($i);
            $i++;
        }

        $rules[$rule."/?$"] = $query;
        $rules[$rule."/feed/(feed|rdf|rss|rss2|atom)/?$"] = $query."&feed=".$wp_rewrite->preg_index($i);
        $rules[$rule."/(feed|rdf|rss|rss2|atom)/?$"] = $query."&feed=".$wp_rewrite->preg_index($i);
        $rules[$rule."/page/([0-9]{1,})/?$"] = $query."&paged=".$wp_rewrite->preg_index($i);
    }
    return $rules;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Add meta box to posts with layout options 
$prefix = 'satori_';
$meta_box = array(
'id' => 'post-layout-choice',
'title' => 'Post Layout',
'page' => 'post',
'context' => 'side',
'priority' => 'core',
'fields' => array(
	array(
		'name' => 'Pick one:',
		'id' => $prefix . 'post-layout',
		'type' => 'select',
		'options' => array('Right Sidebar','Full Width','Left Sidebar')
	)
)
);

add_action('admin_menu', 'post_layout_add_box');
// Add meta box
function post_layout_add_box() {
	global $meta_box;
	$types = array('post', 'project');
	foreach ( $types as $type ) {
	add_meta_box($meta_box['id'], $meta_box['title'], 'post_layout_show_box', $type, $meta_box['context'], $meta_box['priority']);
	}
}

// Callback function to show fields in meta box
function post_layout_show_box() {
global $meta_box, $post;
// Use nonce for verification
echo '<input type="hidden" name="mytheme_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
echo '<table class="form-table">';
foreach ($meta_box['fields'] as $field) {
	// get current post meta data
	$meta = get_post_meta($post->ID, $field['id'], true);
	echo '<tr>',
			'<th style="width:30%"><label for="', $field['id'], '">', $field['name'], '</label></th>',
			'<td>';
	switch ($field['type']) {
		case 'text':
			echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />', '<br />', $field['desc'];
			break;
		case 'textarea':
			echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>', '<br />', $field['desc'];
			break;
		case 'select':
			echo '<select name="', $field['id'], '" id="', $field['id'], '" width="80%">';
			foreach ($field['options'] as $option) {
				echo '<option ', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
			}
			echo '</select>';
			break;
		case 'radio':
			foreach ($field['options'] as $option) {
				echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
			}
			break;
		case 'checkbox':
			echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
			break;
	}
	echo     '</td><td>',
		'</td></tr>';
}
echo '</table>';
}

add_action('save_post', 'mytheme_save_data');
// Save data from meta box
function mytheme_save_data($post_id) {
global $meta_box;
// verify nonce
$post_nonce = ( isset( $_POST[ 'mytheme_meta_box_nonce' ] ) ? $_POST[ 'mytheme_meta_box_nonce' ] : false );
if (!wp_verify_nonce($post_nonce, basename(__FILE__))) {
	return $post_id;
}
// check autosave
if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
	return $post_id;
}
// check permissions
if ('page' == $_POST['post_type']) {
	if (!current_user_can('edit_page', $post_id)) {
		return $post_id;
	}
} elseif (!current_user_can('edit_post', $post_id)) {
	return $post_id;
}
foreach ($meta_box['fields'] as $field) {
	$old = get_post_meta($post_id, $field['id'], true);
	$new = $_POST[$field['id']];
	if ($new && $new != $old) {
		update_post_meta($post_id, $field['id'], $new);
	} elseif ('' == $new && $old) {
		delete_post_meta($post_id, $field['id'], $old);
	}
}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Get URL of first image in a post
function catch_first_image() {
global $post, $posts;
$first_img = '';
ob_start();
ob_end_clean();
$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
$first_img = $matches [1] [0];
return $first_img;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Remove Option Tree From User Profile
global $ot_admin;remove_action( 'show_user_profile', array( $ot_admin, 'option_tree_extra_profile_fields' ) );remove_action( 'edit_user_profile', array( $ot_admin, 'option_tree_extra_profile_fields' ) );remove_action( 'personal_options_update', array( $ot_admin, 'option_tree_save_extra_profile_fields' ) );remove_action( 'edit_user_profile_update', array( $ot_admin, 'option_tree_save_extra_profile_fields' ) );

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom search form
function fuji_search_form( $form ) {
$form = '<form role="search" method="get" id="searchform" action="' . home_url( '/' ) . '" >
<div><input type="text" value="'.__('Find..', 'satori').'" name="s" id="s" />
<input type="submit" id="searchsubmit" value="" />
</div>
</form>';
return $form;
}
add_filter( 'get_search_form', 'fuji_search_form' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Post format support
add_theme_support( 'post-formats', array( 'aside', 'gallery', 'quote', 'video', 'link', 'image' ) );

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add meta box to portfolio items with post box size options 
$prefix = 'satori_';
$meta_box_size = array(
'id' => 'post-size-choice',
'title' => 'Post Box Size',
'page' => 'project',
'context' => 'side',
'priority' => 'core',
'fields' => array(
	array(
		'name' => 'Choose size:',
		'id' => $prefix . 'post-size',
		'type' => 'select',
		'options' => array('1x1','2x2','1x2','2x1','2x3','3x2','3x3','2x4','4x2','3x4','4x3','4x4')
	)
)
);

add_action('admin_menu', 'post_size_add_box');
// Add meta box
function post_size_add_box($postType) {
	global $meta_box_size;
	$types = array('project');
	foreach ( $types as $type ) {
		add_meta_box($meta_box_size['id'], $meta_box_size['title'], 'post_size_show_box', $type, $meta_box_size['context'], $meta_box_size['priority']);
	}
}

// Callback function to show fields in meta box
function post_size_show_box() {
global $meta_box_size, $post;
// Use nonce for verification
echo '<input type="hidden" name="size_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
echo '<table class="form-table">';
foreach ($meta_box_size['fields'] as $field) {
	// get current post meta data
	$meta = get_post_meta($post->ID, $field['id'], true);
	echo '<tr>',
			'<th style="width:30%"><label for="', $field['id'], '">', $field['name'], '</label></th>',
			'<td>';
	switch ($field['type']) {
		case 'text':
			echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />', '<br />', $field['desc'];
			break;
		case 'textarea':
			echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>', '<br />', $field['desc'];
			break;
		case 'select':
			echo '<select name="', $field['id'], '" id="', $field['id'], '" width="80%">';
			foreach ($field['options'] as $option) {
				echo '<option ', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
			}
			echo '</select>';
			break;
		case 'radio':
			foreach ($field['options'] as $option) {
				echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
			}
			break;
		case 'checkbox':
			echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
			break;
	}
	echo     '</td><td>',
		'</td></tr>';
}
echo '</table>';
}

add_action('save_post', 'size_save_data');
// Save data from meta box
function size_save_data($post_id) {
global $meta_box_size;
// verify nonce
$post_nonce = ( isset( $_POST[ 'size_meta_box_nonce' ] ) ? $_POST[ 'size_meta_box_nonce' ] : false );
if (!wp_verify_nonce($post_nonce, basename(__FILE__))) {
	return $post_id;
}
// check autosave
if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
	return $post_id;
}
// check permissions
if ('page' == $_POST['post_type']) {
	if (!current_user_can('edit_page', $post_id)) {
		return $post_id;
	}
} elseif (!current_user_can('edit_post', $post_id)) {
	return $post_id;
}
foreach ($meta_box_size['fields'] as $field) {
	$old = get_post_meta($post_id, $field['id'], true);
	$new = $_POST[$field['id']];
	if ($new && $new != $old) {
		update_post_meta($post_id, $field['id'], $new);
	} elseif ('' == $new && $old) {
		delete_post_meta($post_id, $field['id'], $old);
	}
}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Add meta box to posts with the "sticky post" option 
$prefix = 'satori_';
$sticky_meta_box = array(
'id' => 'post-sticky-choice',
'title' => 'Sticky (Always First)',
'page' => 'project',
'context' => 'side',
'priority' => 'core',
'fields' => array(
	array(
		'name' => 'Make project sticky',
		'id' => $prefix . 'post-sticky',
		'type' => 'checkbox'
	)
)
);

add_action('admin_menu', 'post_sticky_add_box');
// Add meta box
function post_sticky_add_box() {
	global $sticky_meta_box;
	$types = array('project');
	foreach ( $types as $type ) {
	add_meta_box($sticky_meta_box['id'], $sticky_meta_box['title'], 'post_sticky_show_box', $type, $sticky_meta_box['context'], $sticky_meta_box['priority']);
	}
}

// Callback function to show fields in meta box
function post_sticky_show_box() {
global $sticky_meta_box, $post;
// Use nonce for verification
echo '<input type="hidden" name="sticky_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
echo '<table class="form-table sticky">';
foreach ($sticky_meta_box['fields'] as $field) {
	// get current post meta data
	$meta = get_post_meta($post->ID, $field['id'], true);
	echo '<tr>',
			'<th style="width:50%"><label for="', $field['id'], '">', $field['name'], '</label></th>',
			'<td>';
	switch ($field['type']) {
		case 'text':
			echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />', '<br />', $field['desc'];
			break;
		case 'textarea':
			echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>', '<br />', $field['desc'];
			break;
		case 'select':
			echo '<select name="', $field['id'], '" id="', $field['id'], '" width="80%">';
			foreach ($field['options'] as $option) {
				echo '<option ', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
			}
			echo '</select>';
			break;
		case 'radio':
			foreach ($field['options'] as $option) {
				echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
			}
			break;
		case 'checkbox':
			echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
			break;
	}
	echo     '</td><td>',
		'</td></tr>';
}
echo '</table>';
}

add_action('save_post', 'sticky_save_data');
// Save data from meta box
function sticky_save_data($post_id) {
global $sticky_meta_box;
// verify nonce
$post_nonce = ( isset( $_POST[ 'sticky_meta_box_nonce' ] ) ? $_POST[ 'sticky_meta_box_nonce' ] : false );
if (!wp_verify_nonce($post_nonce, basename(__FILE__))) {
	return $post_id;
}
// check autosave
if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
	return $post_id;
}
// check permissions
if ('page' == $_POST['post_type']) {
	if (!current_user_can('edit_page', $post_id)) {
		return $post_id;
	}
} elseif (!current_user_can('edit_post', $post_id)) {
	return $post_id;
}
foreach ($sticky_meta_box['fields'] as $field) {
	$old = get_post_meta($post_id, $field['id'], true);
	$new = $_POST[$field['id']];
	if ($new && $new != $old) {
		update_post_meta($post_id, $field['id'], $new);
	} elseif ('' == $new && $old) {
		delete_post_meta($post_id, $field['id'], $old);
	}
}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Add meta box to portfolio items with background color option 
$prefix = 'satori_';
$color_meta_box = array(
'id' => 'project-color-choice',
'title' => 'Background Color',
'page' => 'project',
'context' => 'side',
'priority' => 'core',
'fields' => array(
	array(
		'name' => 'Input color in <a href="http://www.w3schools.com/tags/ref_colorpicker.asp" target="_blank">hex code</a>',
		'id' => $prefix . 'project-background',
		'type' => 'text',
		'desc' => '',
		'std' => ''
	)
)
);

add_action('admin_menu', 'project_color_add_box');
// Add meta box
function project_color_add_box() {
	global $color_meta_box;
	$types = array('project');
	foreach ( $types as $type ) {
	add_meta_box($color_meta_box['id'], $color_meta_box['title'], 'project_color_show_box', $type, $color_meta_box['context'], $color_meta_box['priority']);
	}
}

// Callback function to show fields in meta box
function project_color_show_box() {
global $color_meta_box, $post;
// Use nonce for verification
echo '<input type="hidden" name="background_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
echo '<table class="form-table">';
foreach ($color_meta_box['fields'] as $field) {
	// get current post meta data
	$meta = get_post_meta($post->ID, $field['id'], true);
	echo '<tr>',
			'<th style="width:30%"><label for="', $field['id'], '">', $field['name'], '</label></th>',
			'<td>';
	switch ($field['type']) {
		case 'text':
			echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />', '<br />', $field['desc'];
			break;
		case 'textarea':
			echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>', '<br />', $field['desc'];
			break;
		case 'select':
			echo '<select name="', $field['id'], '" id="', $field['id'], '" width="80%">';
			foreach ($field['options'] as $option) {
				echo '<option ', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
			}
			echo '</select>';
			break;
		case 'radio':
			foreach ($field['options'] as $option) {
				echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
			}
			break;
		case 'checkbox':
			echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
			break;
	}
	echo     '</td><td>',
		'</td></tr>';
}
echo '</table>';
}

add_action('save_post', 'background_save_data');
// Save data from meta box
function background_save_data($post_id) {
global $color_meta_box;
// verify nonce
$post_nonce = ( isset( $_POST[ 'background_meta_box_nonce' ] ) ? $_POST[ 'background_meta_box_nonce' ] : false );
if (!wp_verify_nonce($post_nonce, basename(__FILE__))) {
	return $post_id;
}
// check autosave
if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
	return $post_id;
}
// check permissions
if ('page' == $_POST['post_type']) {
	if (!current_user_can('edit_page', $post_id)) {
		return $post_id;
	}
} elseif (!current_user_can('edit_post', $post_id)) {
	return $post_id;
}
foreach ($color_meta_box['fields'] as $field) {
	$old = get_post_meta($post_id, $field['id'], true);
	$new = $_POST[$field['id']];
	if ($new && $new != $old) {
		update_post_meta($post_id, $field['id'], $new);
	} elseif ('' == $new && $old) {
		delete_post_meta($post_id, $field['id'], $old);
	}
}
}


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Add custom post class for box size
function large_size_class($classes) {
	global $post;
	$postclass = '';
	if ( 
		get_post_meta($post->ID, 'satori_post-size', true) != '1x1' &&
		get_post_meta($post->ID, 'satori_post-size', true) != '2x1' &&
		get_post_meta($post->ID, 'satori_post-size', true) != '1x2'
	) {
		$postclass .= ' post-size-large';
	}
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '1x1' ) {
		$postclass .= ' post-size-1x1';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '2x1' ) {
		$postclass .= ' post-size-2x1';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '1x2' ) {
		$postclass .= ' post-size-1x2';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '2x2' ) {
		$postclass .= ' post-size-2x2';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '2x3' ) {
		$postclass .= ' post-size-2x3';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '3x2' ) {
		$postclass .= ' post-size-3x2';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '3x3' ) {
		$postclass .= ' post-size-3x3';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '3x4' ) {
		$postclass .= ' post-size-3x4';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '4x3' ) {
		$postclass .= ' post-size-4x3';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '4x4' ) {
		$postclass .= ' post-size-4x4';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '4x2' ) {
		$postclass .= ' post-size-4x2';
	} 
	if ( get_post_meta($post->ID, 'satori_post-size', true) == '2x4' ) {
		$postclass .= ' post-size-2x4';
	} 
	$classes[0] = $postclass;
	return $classes;
}
add_filter('post_class', 'large_size_class');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

?>